#NoTrayIcon
Opt("MustDeclareVars", 1)
Opt("TrayMenuMode", 3)
Opt("TrayOnEventMode", 1)
Const $prg = StringLeft(@ScriptName, StringInStr(@ScriptName, ".", 0, -1) -1)
Const $hdr = "Content-Type: application/json; charset=utf-8" & @crlf & _
"User-Agent: AutoIt v3 - " & @AutoItVersion & @crlf & "Content-Length: "
Const $success = "{""returncode"":""success""}"
Const $p_id = "", $p_lst = "", $p_name = "", $p_url = "", $set = 1
Global $b, $c, $d[18], $e[11][3], $g, $k, $n
Global $p[10][3], $r, $s[10], $u, $w[25][2], $z
Global $an, $cb, $id, $mode, $model, $name, $sc, $soc, $stat, $swver, $tt
Global $date, $handle, $pid = 0, $size, $titel[2], $txt, $wahl, $uuid
Global $ini = StringLeft(@ScriptFullPath, StringInStr(@ScriptFullPath, ".", 0, -1)) & "ini"
If StringInStr(FileGetAttrib(@ScriptDir), "R") Then
  $txt = @LocalAppDataDir & "\" & $prg
  If Not FileExists($txt) Then
    If DirCreate($txt) = 0 Then
      MsgBox(16, $prg, "Das Datenverzeichnis konnte nicht angelegt werden.")
      Exit
    EndIf
  EndIf
  $ini = StringReplace($ini, @ScriptDir, $txt)
EndIf
Global $sender[2] = [IniRead($ini, $prg, "Senderliste", StringLeft($ini, StringInStr($ini, "\", 0, -1)) & "Sender.ini")]
Global $edit = IniRead($ini, $prg, "Editor", @WindowsDir & "\notepad.exe")
Global $host[2] = [IniRead($ini, $prg, "Host", "192.168.2.1")], $ip[2]
If $CmdLine[0] >= 1 Then $host[0] = $cmdLine[1]
Const $port = IniRead($ini, $prg, "Port", 8989)
Const $api = IniRead($ini, $prg, "API", "v19")
Const $to = IniRead($ini, $prg, "TCPTimeout", 1000)
Const $updateurl = IniRead($ini, $prg, "Update_URL", "http://dl.lintech.de/api/v10/upgrate.php?model=%model%&swver=%swver%")
#Include <misc.au3>
If _Singleton($prg, 1) = 0 Then
  MsgBox(64, $prg, "Das Programm luft bereits.")
  Exit
EndIf
#Include <WinAPI.au3>
#Include <Inet.au3>
$cb = IniRead($ini, $prg, "Zwischenablage", 0)
If ($cb < 0) Or ($cb > 1) Then $cb = 1
$tt = IniRead($ini, $prg, "Sprechblasen", 0)
If ($tt < 0) Or ($tt > 1) Then $tt = 1
TCPStartup()
If @ERROR Then
  MsgBox(16, $prg, "Fehler bei der Initialisierung der TCP-Ferbindung.")
  Exit
EndIf
$s[0] = TrayCreateMenu("Wiedergabe&steuerung")
$s[1] = TrayCreateItem("S&enderliste abspielen", $s[0])
TrayItemSetOnEvent($s[1], "ListeAbspielen")
$s[2] = TrayCreateItem("&Wiedergabe", $s[0])
TrayItemSetOnEvent($s[2], "Wiedergabe")
$s[3] = TrayCreateItem("&Pause / fortsetzen", $s[0])
TrayItemSetOnEvent($s[3], "PauseFortsetzen")
$s[4] = TrayCreateItem("&Vorheriger Sender", $s[0])
TrayItemSetOnEvent($s[4], "VorigerSender")
$s[5] = TrayCreateItem("&Nchster Sender", $s[0])
TrayItemSetOnEvent($s[5], "NaechsterSender")
$s[6] = TrayCreateItem("&Stop", $s[0])
TrayItemSetOnEvent($s[6], "WiedergabeStop")
$s[7] = TrayCreateItem("Lautst&rke ndern", $s[0])
TrayItemSetOnEvent($s[7], "Lautstaerke")
$s[8] = TrayCreateItem("Standard-Sender &festlegen", $s[0])
TrayItemSetOnEvent($s[8], "StandardSender")
$s[9] = TrayCreateItem("Standard-Sender&liste festlegen", $s[0])
TrayItemSetOnEvent($s[9], "StandardListe")
$p[0][0] = TrayCreateMenu("Gru&ppenwiedergabe")
$p[0][1] = TrayCreateItem("Gruppenwiedergabe &aktivieren", $p[0][0])
TrayItemSetOnEvent($p[0][1], "Gruppe")
$p[0][2] = TrayCreateItem("Gert hin&zufgen", $p[0][0])
TrayItemSetOnEvent($p[0][2], "GeraetHinzufuegen")
$p[1][1] = 2
$g = TrayCreateItem("&Gertenamen ndern")
TrayItemSetOnEvent($g, "Geraetename")
$d[0] = TrayCreateMenu("Befehl sen&den")
$d[1] = TrayCreateItem("device", $d[0])
TrayItemSetOnEvent($d[1], "Nutzerbefehl")
$d[2] = TrayCreateItem("network", $d[0])
TrayItemSetOnEvent($d[2], "Nutzerbefehl")
$d[3] = TrayCreateItem("wifi", $d[0])
TrayItemSetOnEvent($d[3], "Nutzerbefehl")
$d[4] = TrayCreateItem("otaupgrade", $d[0])
TrayItemSetOnEvent($d[4], "Nutzerbefehl")
$d[5] = TrayCreateItem("radio", $d[0])
TrayItemSetOnEvent($d[5], "Nutzerbefehl")
$d[6] = TrayCreateItem("tidal", $d[0])
TrayItemSetOnEvent($d[6], "Nutzerbefehl")
$d[7] = TrayCreateItem("qobuz", $d[0])
TrayItemSetOnEvent($d[7], "Nutzerbefehl")
$d[8] = TrayCreateItem("player", $d[0])
TrayItemSetOnEvent($d[8], "Nutzerbefehl")
$d[9] = TrayCreateItem("songcast/sender", $d[0])
TrayItemSetOnEvent($d[9], "Nutzerbefehl")
$d[10] = TrayCreateItem("songcast/receiver", $d[0])
TrayItemSetOnEvent($d[10], "Nutzerbefehl")
$d[11] = TrayCreateItem("leds", $d[0])
TrayItemSetOnEvent($d[11], "Nutzerbefehl")
$d[12] = TrayCreateItem("linein", $d[0])
TrayItemSetOnEvent($d[12], "Nutzerbefehl")
$d[13] = TrayCreateItem("sound", $d[0])
TrayItemSetOnEvent($d[13], "Nutzerbefehl")
$d[14] = TrayCreateItem("airplay", $d[0])
TrayItemSetOnEvent($d[14], "Nutzerbefehl")
$d[15] = TrayCreateItem("spotify", $d[0])
TrayItemSetOnEvent($d[15], "Nutzerbefehl")
$d[16] = TrayCreateItem("upnp", $d[0])
TrayItemSetOnEvent($d[16], "Nutzerbefehl")
$d[17] = TrayCreateItem("iperf", $d[0])
TrayItemSetOnEvent($d[17], "Nutzerbefehl")
$u = TrayCreateItem("Nach Firmware&update suchen")
TrayItemSetOnEvent($u, "UpdateSuchen")
$n = TrayCreateItem("AirLino &neu starten")
TrayItemSetOnEvent($n, "Neustart")
$r = TrayCreateItem("Ande&ren AirLino whlen")
TrayItemSetOnEvent($r, "IPErmitteln")
$z = TrayCreateItem("Aktuellen Titel in &Zwischenablage kopieren")
TrayItemSetOnEvent($z, "Zwischenablage")
If $cb = 1 Then TrayItemSetState($z, 1)
$c = TrayCreateItem("Neue Titel als Spre&chblasen zeigen")
TrayItemSetOnEvent($c, "Sprechblasen")
If $tt = 1 Then TrayItemSetState($c, 1)
$k = TrayCreateItem("&Konfiguration speichern")
TrayItemSetOnEvent($k, "IniSchreiben")
$b = TrayCreateItem($prg & " &beenden")
TrayItemSetOnEvent($b, "_Exit")
TraySetState()
If IPErmitteln(0) = 1 Then _Exit()
While 1
  Sleep(5000)
  If $mode = "station" Then Status(0)
  If ($pid <> 0) And (Not ProcessExists($pid)) Then
    $pid = 0
    If ($size <> FileGetSize($sender[0])) Or _
    ($date < FileGetTime($sender[0], 0, 1)) Then Senderliste(1, $sender[0])
  EndIf
WEnd
_Exit()

Func Senderwahl()
  $id = @TRAY_ID - $w[0][0]
  $txt = TrayItemGetText(@TRAY_ID)
  $stat = Abfrage("radio", "{""action"":""getfavouritestation""}")
  If (Not @ERROR) And ((StringInStr($stat, $txt) = 0) Or (StringInStr($stat, $w[$id][1]) = 0)) Then
    $wahl = MsgBox(292, $prg, "Soll " & $txt & " als neuer Standard-Sender festgelegt werden?", 10)
    If $wahl = 6 Then StandardSender($txt, $w[$id][1])
  EndIf
  $stat = Abfrage("radio", StringFormat( _
  "{""action"":""play"",""station"":" & _
  "{""name"":""%s"",""url"":""%s""}}", $txt, $w[$id][1]))
  If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
EndFunc

Func ListeAbspielen()
  Local $pos = 0
  $id = EingabeZahl()
  If @ERROR = 1 Then Return 1
  If @EXTENDED Then $pos = @EXTENDED
  ListePruefen($id, 0)
  If @ERROR Then Return
  $stat = Abfrage("radio", "{""action"":""getfavouriteplaylist""}")
  If @ERROR = 0 Then
    $txt = StringMid($stat, StringInStr($stat, """listid"":") +10)
    $txt = StringLeft($txt, StringInStr($txt, """") -1)
    If $id <> $txt Then
      $wahl = MsgBox(292, $prg, "Soll diese Liste als neue Standard-Senderliste festgelegt werden?", 10)
      If $wahl = 6 Then StandardListe($id)
    EndIf
  EndIf
  If $pos > 0 Then
    $stat = Abfrage("radio", StringFormat( _
    "{""action"":""playplaylist"",""listid"":%s,""pos"":%s}", $id, $pos))
  Else
    $stat = Abfrage("radio", StringFormat( _
    "{""action"":""playplaylist"",""listid"":%s}", $id))
  EndIf
  If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
EndFunc

Func Wiedergabe()
  $stat = Abfrage("songcast/receiver", "{""action"":""state""}")
  If @ERROR Then MsgBox(16, $prg, $stat)
  If ($stat = "{""state"":0}") Or StringInStr($stat, $uuid) Then
    $stat = Abfrage("player", "{""action"":""play""}")
  Else
    $stat = Abfrage("songcast/receiver", "{""action"":""play""}")
  EndIf
  If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
EndFunc

Func PauseFortsetzen()
  $stat = Abfrage("songcast/receiver", "{""action"":""state""}")
  If @ERROR Then MsgBox(16, $prg, $stat)
  If ($stat = "{""state"":0}") Or StringInStr($stat, $uuid) Then
    $stat = Abfrage("player", "{""action"":""playpause""}")
  Else
    If StringInStr($stat, """state"":1") Then
      $txt = "{""action"":""play""}"
    Else
      $txt = "{""action"":""stop""}"
    EndIf
    $stat = Abfrage("songcast/receiver", $txt)
  EndIf
  If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
EndFunc

Func VorigerSender()
  $stat = Abfrage("player", "{""action"":""prev""}")
  If @ERROR Then MsgBox(16, $prg, $stat)
EndFunc

Func NaechsterSender()
  $stat = Abfrage("player", "{""action"":""next""}")
  If @ERROR Then MsgBox(16, $prg, $stat)
EndFunc

Func WiedergabeStop()
  $stat = Abfrage("songcast/receiver", "{""action"":""state""}")
  If @ERROR Then MsgBox(16, $prg, $stat)
  If ($stat = "{""state"":0}") Or StringInStr($stat, $uuid) Then
    $stat = Abfrage("player", "{""action"":""stop""}")
  Else
    $stat = Abfrage("songcast/receiver", "{""action"":""stop""}")
  EndIf
  If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
EndFunc

Func StandardSender($p_name=$p_name,$p_url=$p_url)
  Local $s_name = $p_name, $s_url = $p_url
  If ($s_name = "") Or ($s_url = "") Then
    $stat = Abfrage("radio", "{""action"":""getfavouritestation""}")
    If @ERROR Then MsgBox(16, $prg, $stat)
    If $stat <> "{}" Then
      $s_name = StringMid($stat, StringInStr($stat, """name"":") +8)
      $s_name = StringLeft($s_name, StringInStr($s_name, """") -1)
      $s_url = StringMid($stat, StringInStr($stat, """url"":") +7)
      $s_url = StringLeft($s_url, StringInStr($s_url, """") -1)
    EndIf
    $s_name = InputBox($prg, "Name des gewnschten Standard-Senders:", $s_name)
    If @ERROR = 1 Then Return
    If $s_name <> "" Then
      $s_url = InputBox($prg, "URL zum Stream des Senders:", $s_url)
      If @ERROR = 1 Then Return
    EndIf
  EndIf
  If ($s_name = "") Or ($s_url = "") Then
    $stat = Abfrage("radio", "{""action"":""setfavouritestation""}")
    If @ERROR Or ($stat <> $success) Then
      MsgBox(16, $prg, $stat)
    Else
      MsgBox(64, $prg, "Der Standard-Sender wurde gelscht.")
    EndIf
  ElseIf StringInStr($stat, $s_name) And StringInStr($stat, $s_url) Then
    MsgBox(64, $prg, $s_name & " wird unverndert als Standard-Sender beibehalten.")
  Else
    $stat = Abfrage("radio", StringFormat( _
    "{""action"":""setfavouritestation"",""station"":" & _
    "{""name"":""%s"",""url"":""%s""}}", $s_name, $s_url))
    If @ERROR Or ($stat <> $success) Then
      MsgBox(16, $prg, $stat)
    Else
      MsgBox(64, $prg, $s_name & " wurde als Standard-Sender festgelegt.")
    EndIf
  EndIf
EndFunc

Func StandardListe($p_id=$p_id)
  Local $s_id = $p_id
  If $s_id = "" Then
    $stat = Abfrage("radio", "{""action"":""getfavouriteplaylist""}")
    If @ERROR Then MsgBox(16, $prg, $stat)
    If $stat <> "{}" Then
      $s_id = StringMid($stat, StringInStr($stat, """listid"":") +10)
      $s_id = StringLeft($s_id, StringInStr($s_id, """") -1)
    EndIf
    Do
      $s_id = InputBox($prg, "Nummer der gewnschten " & _
      "Standard-Senderliste (0 - 128):", $s_id)
      If @ERROR = 1 Then Return
    Until (StringIsDigit($s_id) And ($s_id >= 0) And ($s_id <= 128)) _
    Or $s_id = ""
  EndIf
  If $s_id = "" Then
    $stat = Abfrage("radio", "{""action"":""setfavouriteplaylist""}")
    If @ERROR Or ($stat <> $success) Then
      MsgBox(16, $prg, $stat)
    Else
      MsgBox(64, $prg, "Die Standard-Senderliste wurde gelscht.")
    EndIf
  ElseIf StringInStr($stat, $s_id) Then
    MsgBox(64, $prg, $s_id & " wird unverndert als Standard-Senderliste beibehalten.")
  Else
    If $p_id = "" Then
      ListePruefen($s_id)
      If @ERROR Then Return
    EndIf
    $stat = Abfrage("radio", StringFormat( _
    "{""action"":""setfavouriteplaylist"",""listid"":""%s""}", $s_id))
    If @ERROR Or ($stat <> $success) Then
      MsgBox(16, $prg, $stat)
    Else
      $stat = Abfrage("radio", "{""action"":""getfavouritestation""}")
      If @ERROR Then
        MsgBox(16, $prg, $stat)
      Else
        If $stat = "{}" Then
          MsgBox(64, $prg, $s_id & " wurde als Standard-Senderliste festgelegt.")
        Else
          $wahl = MsgBox(292, $prg, $s_id & " wurde als Standard-" & _
          "Senderliste festgelegt. In Ihrem AirLino ist allerdings " & _
          "zustzlich auch ein Standard-Sender eingestellt. Dieser hat " & _
          "grundstzlich Vorrang vor der Standard-Senderliste." & @crlf & _
          "Mchten Sie den Standard-Sender jetzt lschen?", 10)
          If $wahl <> 6 Then Return
          $stat = Abfrage("radio", "{""action"":""setfavouritestation""}")
          If @ERROR Or ($stat <> $success) Then
            MsgBox(16, $prg, $stat)
          Else
            MsgBox(64, $prg, "Der Standard-Sender wurde gelscht.")
          EndIf
        EndIf
      EndIf
    EndIf
  EndIf
EndFunc

Func Lautstaerke($set=$set)
  Local $vol[2]
  TraySetToolTip($prg & ": (Lautstrke wird abgefragt)")
  $stat = Abfrage("sound", "{""action"":""getmastervol""}")
  If @ERROR Then MsgBox(16, $prg, $stat)
  If StringInStr($stat, """volume"":") Then
    $vol[0] = StringMid($stat, StringInStr($stat, """volume"":") +9)
    $vol[0] = StringLeft($vol[0], StringInStr($vol[0], "}") -1)
    If $set = 0 Then
      $vol[1] = IniRead($ini, $prg, "Lautstaerke", $vol[0])
      If $vol[0] <> $vol[1] Then
        TraySetToolTip($prg & ": (Lautstrke wird korrigiert)")
        $vol[0] = $vol[1]
        $stat = Abfrage("sound", StringFormat( _
        "{""action"":""setmastervol"",""volume"":%s}", $vol[0]))
        If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
        If FileExists($ini) Then IniWrite($ini, $prg, "Lautstaerke", $vol[0])
      EndIf
    EndIf
    $vol[1] = Round(100 / 255 * $vol[0])
  Else
    $vol[0] = 192
    $vol[1] = 75
  EndIf
  If $set = 1 Then
    Do
      $vol[1] = InputBox($prg, "Gewnschte Lautstrke in Prozent:", $vol[1], " m")
      If @ERROR = 1 Then
        TraySetToolTip($titel[0])
        Return
      EndIf
    Until StringIsDigit($vol[1])
    If $vol[1] > 100 Then $vol[1] = 100
    If $vol[1] < 0 Then $vol[1] = 0
    $vol[0] = Ceiling(255 / 100 * $vol[1])
    TraySetToolTip($prg & ": (Lautstrke wird gendert)")
    $stat = Abfrage("sound", StringFormat( _
    "{""action"":""setmastervol"",""volume"":%s}", $vol[0]))
    If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
    If FileExists($ini) Then IniWrite($ini, $prg, "Lautstaerke", $vol[0])
    TraySetToolTip($titel[0])
  EndIf
  TrayItemSetText($s[7], "Lautst&rke ndern (" & $vol[1] & " %)")
EndFunc

Func Gruppe()
  If BitAND(TrayItemGetState($p[0][1]), 1) Then
    For $x = ($p[1][1] -1) To 2 Step -1
      TraySetToolTip($prg & ": (" & $p[$x][0] & " wird aus Gruppe entfernt)")
      $ip[0] = $p[$x][1]
      $stat = Abfrage("songcast/receiver", "{""action"":""unlink""}")
      If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
      TrayItemDelete($p[$x][2])
    Next
    TraySetToolTip($prg & ": (Gruppenwiedergabe wird deaktiviert)")
    $ip[0] = $ip[1]
    TrayItemDelete($p[1][0])
    $p[1][1] = 2
    $stat = Abfrage("songcast/sender", "{""action"":""disable""}")
    If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
    TrayItemSetState($p[0][1], 4)
    TrayItemSetState($p[0][2], 128)
  Else
    $stat = Abfrage("songcast/receiver", "{""action"":""state""}")
    If @ERROR Then MsgBox(16, $prg, $stat)
    If ($stat <> "{""state"":0}") And (StringInStr($stat, $uuid) = 0) Then
      $wahl = MsgBox(292, $prg, "Dieser AirLino ist bereits als Empfnger " & _
      "in einer Gruppe aktiv. Mchten Sie diese Konfiguration jetzt " & _
      "lschen und den AirLino als Sender konfigurieren?", 10)
      If $wahl = 6 Then
        $stat = Abfrage("songcast/receiver", "{""action"":""unlink""}")
        If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
      Else
        Return
      EndIf
    EndIf
    TraySetToolTip($prg & ": (Gruppenwiedergabe wird aktiviert)")
    $stat = Abfrage("songcast/sender", "{""action"":""enable""," & _
    """groupname"":""Gruppenwiedergabe"",""mode"":0}")
    If @ERROR Then MsgBox(16, $prg, $stat)
    TrayItemSetState($p[0][1], 1)
    TrayItemSetState($p[0][2], 64)
  EndIf
  TraySetToolTip($titel[0])
EndFunc

Func GeraetHinzufuegen()
  If $p[1][1] >= UBound($p) Then
    MsgBox(64, $prg, "Eine Gruppe darf nicht mehr als " & (UBound($p) -1) & _
    " Gerte enthalten.")
    Return
  EndIf
  If IPErmitteln(2) = 1 Then Return
  $stat = Abfrage()
  If @ERROR Then MsgBox(16, $prg, $stat)
  If StringInStr($stat, """devicename"":") = 0 Then
    MsgBox(16, $prg, $host[0] & " scheint kein AirLino zu sein.")
  Else
    $txt = StringMid($stat, StringInStr($stat, """devicename"":") +14)
    $p[$p[1][1]][0] = StringLeft($txt, StringInStr($txt, """") -1)
    $p[$p[1][1]][1] = $ip[0]
    For $x = 2 To ($p[1][1] -1)
      If $p[$x][1] = $p[$p[1][1]][1] Then
        MsgBox(16, $prg, "Der AirLino " & $p[$x][0] & " gehrt bereits zu " & _
        "dieser Gruppe.")
        $host[0] = $host[1]
        $ip[0] = $ip[1]
        Return
      EndIf
    Next
    $stat = Abfrage("songcast/receiver", "{""action"":""state""}")
    If @ERROR Then MsgBox(16, $prg, $stat)
    If ($stat <> "{""state"":0}") And (StringInStr($stat, $uuid) = 0) Then
      $wahl = MsgBox(292, $prg, "Der AirLino " & $p[$p[1][1]][0] & " " & _
      "gehrt bereits zu einer anderen Gruppe. Mchten Sie ihn trotzdem " & _
      "hinzufgen?", 10)
      If $wahl = 6 Then
        $stat = Abfrage("songcast/receiver", "{""action"":""unlink""}")
        If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
      Else
        $host[0] = $host[1]
        $ip[0] = $ip[1]
        Return
      EndIf
    EndIf
    TraySetToolTip($prg & ": (" & $p[$p[1][1]][0] & " wird zur Gruppe hinzugefgt)")
    If StringInStr($stat, $uuid) = 0 Then
      $stat = Abfrage("songcast/receiver", StringFormat( _
      "{""action"":""link"",""uuid"":""%s""}", $uuid))
      If @ERROR Or ($stat <> $success) Then
        MsgBox(16, $prg, "Der gewnschte AirLino konnte nicht zur Gruppe " & _
        "hinzugefgt werden." & @CRLF & $stat)
        $host[0] = $host[1]
        $ip[0] = $ip[1]
        TraySetToolTip($titel[0])
        Return
      EndIf
    EndIf
    If $p[1][1] = 2 Then $p[1][0] = TrayCreateItem("", $p[0][0])
    $p[$p[1][1]][2] = TrayCreateItem($p[$p[1][1]][0] & " entfernen", $p[0][0])
    TrayItemSetOnEvent($p[$p[1][1]][2], "GeraetEntfernen")
    $p[1][1] += 1
  EndIf
  $host[0] = $host[1]
  $ip[0] = $ip[1]
  TraySetToolTip($titel[0])
EndFunc

Func GeraetEntfernen()
  For $x = 2 To ($p[1][1] -1)
    If $p[$x][2] = @TRAY_ID Then
      TraySetToolTip($prg & ": (" & $p[$x][0] & " wird aus Gruppe entfernt)")
      $ip[0] = $p[$x][1]
      $stat = Abfrage("songcast/receiver", "{""action"":""unlink""}")
      If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
      TrayItemDelete($p[$x][2])
      If ($p[1][1] -1) > $x Then
        For $y = $x To ($p[1][1] -1)
          $p[$y][0] = $p[($y +1)][0]
          $p[$y][1] = $p[($y +1)][1]
          $p[$y][2] = $p[($y +1)][2]
        Next
      EndIf
      $p[1][1] -= 1
      ExitLoop
    EndIf
  Next
  If $p[1][1] = 2 Then TrayItemDelete($p[1][0])
  $ip[0] = $ip[1]
  TraySetToolTip($titel[0])
EndFunc

Func Geraetename($set=$set)
  TraySetToolTip($prg & ": (Gerteinformationen werden abgerufen)")
  $stat = Abfrage()
  If @ERROR Then MsgBox(16, $prg, $stat)
  If StringInStr($stat, """firmware"":") Then
    $swver = StringMid($stat, StringInStr($stat, """firmware"":") +12)
    $swver = StringLeft($swver, StringInStr($swver, """") -1)
  EndIf
  If StringInStr($stat, """model"":") Then
    $model = StringMid($stat, StringInStr($stat, """model"":") +9)
    $model = StringLeft($model, StringInStr($model, """") -1)
  EndIf
  If StringInStr($stat, """devicename"":") Then
    $name = StringMid($stat, StringInStr($stat, """devicename"":") +14)
    $name = StringLeft($name, StringInStr($name, """") -1)
  EndIf
  If $set = 1 Then
    $name = InputBox($prg, "Neuer Gertename des AirLino:", $name, " m")
    If @ERROR = 1 Then
      TraySetToolTip($titel[0])
      Return
    EndIf
    TraySetToolTip($prg & ": (Gertename wird gendert)")
    $stat = Abfrage("device", StringFormat( _
    "{""action"":""setdevicename"",""devicename"":""%s""}", $name))
    If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
    TraySetToolTip($titel[0])
  Else
    $stat = Abfrage("songcast/sender", "{""action"":""status""}")
    If @ERROR Then MsgBox(16, $prg, $stat)
    If StringInStr($stat, """enabled"":true") Then
      TrayItemSetState($p[0][1], 1)
      TrayItemSetState($p[0][2], 64)
    EndIf
    If StringInStr($stat, """uuid"":") Then
      $uuid = StringMid($stat, StringInStr($stat, """uuid"":") +8)
      $uuid = StringLeft($uuid, StringInStr($uuid, """") -1)
    EndIf
    If StringInStr($stat, """enabled"":false") Then
      $stat = Abfrage("songcast/receiver", "{""action"":""state""}")
      If @ERROR Then MsgBox(16, $prg, $stat)
      If $stat <> "{""state"":0}" Then
        $wahl = MsgBox(36, $prg, "Dieser AirLino ist als Empfnger in einer " & _
        "Gruppe aktiv. Mchten Sie diese Konfiguration beibehalten?", 10)
        If $wahl <> 6 Then
          $stat = Abfrage("songcast/receiver", "{""action"":""unlink""}")
          If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
        EndIf
      EndIf
    EndIf
  EndIf
  TrayItemSetText($g, "&Gertenamen ndern (" & $name & ")")
  TrayItemSetText($n, $name & " &neu starten")
EndFunc

Func Nutzerbefehl()
  $txt = InputBox($prg, "Befehl fr " & TrayItemGetText(@TRAY_ID) & ".action:", "", " m")
  If @ERROR = 1 Then Return
  If StringLeft($txt, 1) <> "{" Then $txt = "{" & $txt
  If StringRight($txt, 1) <> "}" Then $txt &= "}"
  $stat = Abfrage(TrayItemGetText(@TRAY_ID), $txt)
  If @ERROR Then
    MsgBox(16, $prg, $stat)
  Else
    MsgBox(64, $prg, $stat)
    If $cb = 1 Then ClipPut($stat)
  EndIf
EndFunc

Func Neustart($set=$set)
  If $set = 1 Then
    $stat = Abfrage("device", "{""action"":""reboot""}")
    If @ERROR Or ($stat <> $success) Then
      MsgBox(16, $prg, "Der Neustart konnte nicht Durchgefhrt werden: " & $stat)
      Return
    EndIf
    TraySetToolTip($prg & ": (" & $name & " wird neu gestartet)")
  EndIf
  Sleep(30000)
  TraySetToolTip($prg & ": (suche " & $host[0] & ")")
  For $x = 1 To 10
    If Ping($ip[0], 10000) Then ExitLoop
  Next
  If @ERROR Then
    MsgBox(16, $prg, $host[0] & " wurde nicht gefunden.")
    _Exit()
  EndIf
  Netzwerk()
  Geraetename(0)
  Lautstaerke(0)
  Status()
EndFunc

Func Netzwerk($set=$set)
  If $set = 1 Then
    If TrayItemDelete($e[0][0]) = 0 Then
      MsgBox(16, $prg, "Die Netzwerkliste kann nicht aktualisiert werden, da die alten Eintrge nicht aus dem Speicher gelscht werden konnten.")
      Return
    EndIf
  EndIf
  $stat = Abfrage("network", "{""action"":""info""}")
  If @ERROR Then MsgBox(16, $prg, $stat)
  If StringInStr($stat, """mode"":") Then
    $mode = StringMid($stat, StringInStr($stat, """mode"":") +8)
    $mode = StringLeft($mode, StringInStr($mode, """") -1)
    If $mode = "AP" Then
      $wahl = MsgBox(36, $prg, "Der AirLino ist mit keinem Netzwerk verbunden." & @crlf & _
      "Mchten Sie die Netzwerkverbindung jetzt einrichten?")
      If $wahl = 6 Then
        If NeuesNetz() = 0 Then Return
      EndIf
    EndIf
  Else
    MsgBox(16, $prg, "Beim Zugriff auf den AirLino ist ein Fehler aufgetreten: " & $stat)
    _Exit()
  EndIf
  TraySetToolTip($prg & ": (Netzwerkliste wird abgerufen)")
  $e[0][0] = TrayCreateMenu("N&etzwerk", -1, 4)
  $id = 1
  $stat = Abfrage("wifi", "{""action"":""listnetworks""}")
  If @ERROR Then MsgBox(16, $prg, $stat)
  If $stat <> "[]" Then
    $e[0][1] = TrayCreateMenu("Auswhlen", $e[0][0])
    Do
      $txt = StringMid($stat, StringInStr($stat, """id"":") +5)
      $e[$id][0] = StringLeft($txt, StringInStr($txt, "}") -1)
      $txt = StringMid($stat, StringInStr($stat, """ssid"":") +8)
      $txt = StringLeft($txt, StringInStr($txt, """") -1)
      $e[$id][1] = TrayCreateItem($txt, $e[0][1], -1, 1)
      TrayItemSetOnEvent($e[$id][1], "NetzWaehlen")
      $txt = StringMid($stat, StringInStr($stat, """flags"":") +8)
      $txt = StringLeft($txt, StringInStr($txt, ",") -1)
      If $txt = 2 Then
        TrayItemSetState($e[$id][1], 1)
        $an = $e[$id][0]
      EndIf
      $id += 1
      $stat = StringMid($stat, StringInStr($stat, "}") +1)
    Until (StringInStr($stat, """ssid"":") = 0) Or ($id >= (UBound($e) -1))
    $e[0][2] = TrayCreateMenu("Lschen", $e[0][0])
    For $x = 1 To ($id - 1)
      $e[$x][2] = TrayCreateItem(TrayItemGetText($e[$x][1]), $e[0][2])
      TrayItemSetOnEvent($e[$x][2], "NetzLoeschen")
    Next
  EndIf
  $e[$id][0] = TrayCreateItem("", $e[0][0])
  $e[$id][1] = TrayCreateItem("Neues Netzwerk hinzufgen", $e[0][0])
  TrayItemSetOnEvent($e[$id][1], "NeuesNetz")
  $e[$id][2] = TrayCreateItem("Netzwerkliste neu laden", $e[0][0])
  TrayItemSetOnEvent($e[$id][2], "Netzwerk")
  If $mode = "AP" Then
    TraySetToolTip($prg & ": (keine Netzwerkverbindung)")
  Else
    If $set = 1 Then TraySetToolTip($titel[0])
  EndIf
EndFunc

Func UpdateSuchen()
  Local $dl, $dv, $fs, $url
  $url = StringReplace($updateurl, "%model%", $model)
  $url = StringReplace($url, "%swver%", $swver)
  $txt = BinaryToString(InetRead($url, 1))
  If @ERROR Then
    MsgBox(16, $prg, "Beim Zugriff auf den Updateserver ist ein Fehler aufgetreten.")
    Return
  EndIf
  If $txt = "filenotexist" Then
    MsgBox(64, $prg, "Auf Ihrem AirLino ist bereits die aktuellste " & _
    "Firmware (Version " & $swver & ") installiert.")
    Return
  EndIf
  $dv = StringMid($txt, StringInStr($txt, """destversion"":") +15)
  $dv = StringLeft($dv, StringInStr($dv, """") -1)
  $wahl = MsgBox(36, $prg, "Fr Ihren AirLino ist ein Firmwareupdate von " & _
  "Version " & $swver & " auf Version " & $dv & " verfgbar. " & _
  "Mchten Sie das Update jetzt durchfhren?")
  If $wahl <> 6 Then Return
  $dl = IniRead($ini, $prg, "downloadurl", "")
  $fs = IniRead($ini, $prg, "filesize", "")
  If ($dl = "") Or ($fs = "") Then
    $dl = StringMid($txt, StringInStr($txt, """downloadurl"":") +15)
    $dl = StringLeft($dl, StringInStr($dl, """") -1)
    $dl = StringReplace($dl, "\/", "/")
    $fs = StringMid($txt, StringInStr($txt, """filesize"":") +11)
    $fs = StringLeft($fs, StringInStr($fs, ",") -1)
  EndIf
  TraySetToolTip($prg & ": (Update wird gestartet)")
  $stat = Abfrage("otaupgrade", StringFormat( _
  "{""action"":""seturl"",""otaaddress"":""%s"",""filesize"":""%s""}", $dl, $fs))
  If @ERROR Or ($stat <> $success) Then
    MsgBox(16, $prg, $stat)
    TraySetToolTip($titel[0])
    Return
  EndIf
  Sleep(3000)
  Do
    $stat = Abfrage("otaupgrade", "{""action"":""querystatus""}")
    If @ERROR Then
      MsgBox(16, $prg, $stat)
      ExitLoop
    EndIf
    If StringInStr($stat, """status"":") Then
      $sc = StringMid($stat, StringInStr($stat, """status"":") +10)
      $sc = StringLeft($sc, StringInStr($sc, """") -1)
      Switch $sc
        Case 1
          $txt = "(Update wird heruntergeladen"
          $dl = StringMid($stat, StringInStr($stat, """downprogress"":") +16)
          $dl = StringLeft($dl, StringInStr($dl, """") -1)
          If $dl <> "" Then
            $txt &= " (" & $dl & " %))"
          Else
            $txt &= ")"
          EndIf
        Case 2
          $txt = "(Download abgeschlossen)"
        Case 3, 6
          $txt = "(" & $name & " wird aktualisiert und anschlieend neu gestartet)"
        Case 4
          $txt = "(Update wird berprft)"
        Case 5
          $txt = "Das Update ist fehlerhaft."
          MsgBox(16, $prg, $txt)
        Case Else
          $txt = $stat
          MsgBox(16, $prg, $txt)
      EndSwitch
    EndIf
    TraySetToolTip($prg & ": " & $txt)
    Sleep(1500)
  Until ($sc = 3) Or ($sc >= 5) Or ($sc = "")
  If ($sc <> 5) And ($sc <> "") Then
    Sleep(10000)
    Neustart(0)
  EndIf
  If ($swver <> $dv) Or ($sc = 5) Or ($sc = "") Then _
  MsgBox(16, $prg, "Beim Update der Firmware ist ein Fehler aufgetreten.")
EndFunc

Func IPErmitteln($set=$set)
  If $set <= 1 Then TraySetToolTip($prg)
  If $set >= 1 Then
    $host[0] = InputBox($prg, "Unter welchem Namen bzw. welcher IP ist der " & _
    "gewnschte AirLino im Heimnetz erreichbar?", $host[0], " m")
    If @ERROR = 1 Then
      If $set <= 1 Then TraySetToolTip($titel[0])
      $host[0] = $host[1]
      Return 1
    EndIf
  EndIf
  Do
    $ip[0] = TCPNameToIP($host[0])
    If @ERROR Or (Ping($ip[0], 10000) = 0) Then
      $ip[0] = ""
      $host[0] = InputBox($prg, "Unter " & $host[0] & " konnte kein Gert " & _
      "ermittelt werden." & @crlf & "Unter welchem Namen bzw. welcher IP " & _
      "ist der AirLino im Heimnetz erreichbar?", $host[0], " m")
      If @ERROR = 1 Then
        If $set <= 1 Then TraySetToolTip($titel[0])
        If $set >= 1 Then
          $host[0] = $host[1]
          $ip[0] = $ip[1]
        EndIf
        Return 1
      EndIf
    Else
      If (Not FileExists($ini)) And ($ip[0] <> "192.168.2.1") Then IniSchreiben()
    EndIf
  Until $ip[0] <> ""
  If $set <= 1 Then
    $host[1] = $host[0]
    $ip[1] = $ip[0]
    $name = $host[0]
    If $p[1][1] > 2 Then
      For $x = ($p[1][1] -1) To 2 Step -1
        TrayItemDelete($p[$x][2])
      Next
      $p[1][1] = 2
    EndIf
    TrayItemSetState($p[0][1], 4)
    TrayItemSetState($p[0][2], 128)
  EndIf
  If $set = 1 Then
    Netzwerk()
  ElseIf $set = 0 Then
    Senderliste(0)
    Netzwerk(0)
  EndIf
  If ($mode = "station") And ($set <= 1) Then
    Geraetename(0)
    Lautstaerke(0)
    Status()
  EndIf
EndFunc

Func Zwischenablage($set=$set)
  If $set = 1 Then
    If $cb = 1 Then
      $cb = 0
      TrayItemSetState($z, 4)
    Else
      $cb = 1
      TrayItemSetState($z, 1)
    EndIf
  EndIf
  If $cb = 1 Then
    ClipPut(StringReplace(StringMid($titel[0], StringInStr($titel[0], ": ", 0, -1) +2), "&&", "&"))
  EndIf
EndFunc

Func Sprechblasen($set=$set)
  If $set = 1 Then
    If $tt = 1 Then
      $tt = 0
      TrayItemSetState($c, 4)
    Else
      $tt = 1
      TrayItemSetState($c, 1)
    EndIf
  EndIf
  If $tt = 1 Then
    If StringInStr($stat, """name"":") Then
      $txt = StringMid($stat, StringInStr($stat, """name"":") +8)
      $txt = StringLeft($txt, StringInStr($txt, """") -1)
    Else
      $txt = $prg
    EndIf
    TrayTip($txt, StringMid($titel[0], StringInStr($titel[0], ": ", 0, -1) +2), 20)
  EndIf
EndFunc

Func Status($set=$set)
  If $set = 1 Then
    $titel[1] = ""
    TraySetToolTip($prg & ": (Titel wird abgefragt)")
  EndIf
  $stat = Abfrage("player", "{""action"":""status""}")
  If @ERROR Then
    $sc = 0
    $titel[0] = "(" & $stat & ")"
  Else
    $sc = StringMid($stat, 10, 1)
    Switch $sc
      Case 1
        $titel[0] = "(keine Wiedergabe)"
      Case 2
        $titel[0] = StringMid($stat, StringInStr($stat, """name"":") +8)
        If StringInStr($stat, "now_playing") Then _
        $titel[0] = StringLeft($titel[0], StringInStr($titel[0], """") -1) & _
        ": " & StringMid($stat, StringInStr($stat, "now_playing") +14)
        $titel[0] = StringLeft($titel[0], StringInStr($titel[0], """") -1)
        If StringInStr($titel[0], "&") Then $titel[0] = StringReplace($titel[0], "&", "&&", 1)
        If StringInStr($titel[0], ": ") = 1 Then $titel[0] = StringMid($titel[0], 3)
      Case 3
        $titel[0] = "(Pause)"
    EndSwitch
  EndIf
  If (StringLen($prg) + StringLen($titel[0]) +2) <= 128 Then
    If StringInStr($titel[0], $prg & ": ") = 0 Then $titel[0] = $prg & ": " & $titel[0]
  EndIf
  If $titel[1] <> $titel[0] Then
    $titel[1] = $titel[0]
    TraySetToolTip($titel[0])
    If ($cb = 1) And StringInStr($stat, "now_playing") Then Zwischenablage(0)
    If ($tt = 1) And StringInStr($stat, "now_playing") Then Sprechblasen(0)
  EndIf
EndFunc

Func Verbinden()
  Opt("TCPTimeout", $to)
  For $x = 1 To 10
    $soc = TCPConnect($ip[0], $port)
    If (@ERROR = 0) And ($soc <> -1) Then ExitLoop
    Sleep(5000)
  Next
  If @ERROR Or ($soc = -1) Then
    MsgBox(16, $prg, $host[0] & " ist nicht erreichbar.")
    _Exit()
  EndIf
  Opt("TCPTimeout", Ceiling($to / 10))
EndFunc

Func Abfrage($a="device",$p="{""action"":""info""}")
  Local $err, $req, $res, $tmp
  $tmp = _WinAPI_WideCharToMultiByte($p, 65001)
  $req = "POST /api/" & $api & "/" & $a & ".action" & " HTTP/1.1" & @crlf
  $req &= $hdr & StringLen($tmp) & @crlf
  $req &= "Host: " & $ip[0] & ":" & $port & @crlf
  $req &= "Connection: close" & @crlf & @crlf
  $req &= $tmp
  Sleep(Ceiling($to / 10))
  Verbinden()
  TCPSend($soc, $req)
  $err = @ERROR
  If $err Then
    TCPCloseSocket($soc)
    Return SetError($err, 0, "Fehler beim Senden der Anfrage.")
  EndIf
  $res = ""
  Do
    For $x = 1 To 10
      Do
        Sleep(Ceiling($to / 10))
        $tmp = TCPRecv($soc, 2048)
        $err = @ERROR
        If $err Then ExitLoop
        If @EXTENDED Then ContinueLoop
        $res &= $tmp
      Until $tmp = ""
      If $err Or ($res = "") Then
        $tmp = $name & " antwortet nicht"
        If $err = 0 Then $err = 1
        Sleep(2000)
      Else
        $tmp = BinaryToString(StringMid($res, StringInStr($res, @crlf & @crlf) + 4), 4)
        ExitLoop
      EndIf
    Next
  Until ((StringInStr($p, """reboot""") = 0) And (StringInStr($p, """seturl""") = 0)) _
  Or StringInStr($res, $success)
  TCPCloseSocket($soc)
  Return SetError($err, 0, $tmp)
EndFunc

Func Senderliste($set=$set, $p_lst=$p_lst)
  If $set = 1 Then
    $sender[1] = $sender[0]
    If $p_lst = "" Then
      Do
        $sender[0] = FileOpenDialog($prg, @WorkingDir, "Senderlisten (*.ini)")
        If @ERROR Then
          $sender[0] = $sender[1]
          Return
        EndIf
        If $sender[0] = $ini Then
          $sender[0] = ""
          MsgBox(16, $prg, "Die " & $prg & " Konfigurationsdatei enthlt keine Senderliste.")
        EndIf
      Until $sender[0] <> ""
    Else
      $sender[0] = $p_lst
    EndIf
  EndIf
  If $set >= 1 Then
    If TrayItemDelete($w[0][0]) = 0 Then
      MsgBox(16, $prg, "Die Senderliste kann nicht aktualisiert werden, da die alten Eintrge nicht aus dem Speicher gelscht werden konnten.")
      Return
    EndIf
  EndIf
  $w[0][0] = TrayCreateMenu("Sender &whlen", -1, 0)
  If $set <= 1 Then
    If Not FileExists($sender[0]) Then
      $handle = FileOpen($sender[0], 514)
      If $handle = -1 Then
        MsgBox(16, $prg, "Fehler beim Erstellen der Senderliste.")
        _Exit()
      EndIf
      FileWriteLine($handle, "Pappelkrug")
      FileWriteLine($handle, "http://stream.laut.fm/pappelkrug")
      FileWriteLine($handle, "TEUTO-FM")
      FileWriteLine($handle, "http://stream.laut.fm/teuto-fm")
      FileWriteLine($handle, "Radio Bielefeld")
      FileWriteLine($handle, "http://mp3.radiobielefeld.c.nmdn.net/ps-radiobielefeld/livestream.mp3")
      FileWriteLine($handle, "Radio Hochstift")
      FileWriteLine($handle, "http://mp3.radiohochstift.c.nmdn.net/ps-radiohochstift/livestream.mp3")
      FileWriteLine($handle, "Radio Kln")
      FileWriteLine($handle, "http://mp3.radiokoeln.c.nmdn.net/ps-radiokoeln/livestream.mp3")
      FileWriteLine($handle, "HIT RADIO FFH")
      FileWriteLine($handle, "http://mp3.ffh.de/radioffh/hqlivestream.mp3")
      FileWriteLine($handle, "FFH Eurodance")
      FileWriteLine($handle, "http://mp3.ffh.de/ffhchannels/hqeurodance.mp3")
      FileWriteLine($handle, "FFH Just 90s")
      FileWriteLine($handle, "http://mp3.ffh.de/ffhchannels/hq90er.mp3")
      FileWriteLine($handle, "FFH die 80er")
      FileWriteLine($handle, "http://mp3.ffh.de/ffhchannels/hq80er.mp3")
      FileClose($handle)
    EndIf
    $handle = FileOpen($sender[0], 512)
    If $handle = -1 Then
      MsgBox(16, $prg, "Fehler beim ffnen der Senderliste.")
      _Exit()
    EndIf
    $id = 1
    Do
      $txt = FileReadLine($handle)
      If @ERROR Then ExitLoop
      $w[$id][1] = FileReadLine($handle)
      If @ERROR Then ExitLoop
      $w[$id][0] = TrayCreateItem($txt, $w[0][0])
      TrayItemSetOnEvent($w[$id][0], "Senderwahl")
      $id += 1
    Until @ERROR Or ($id >= (UBound($w) -4))
    FileClose($handle)
    $size = FileGetSize($sender[0])
    $date = FileGetTime($sender[0], 0, 1)
  Else
    $stat = Abfrage("radio", StringFormat( _
    "{""action"":""getplaylist"",""listid"":%s}", $id))
    If @ERROR Then MsgBox(16, $prg, $stat)
    $id = 1
    While StringInStr($stat, """name"":") And StringInStr($stat, """url"":")
      $w[$id][1] = StringMid($stat, StringInStr($stat, """url"":") +7)
      $w[$id][1] = StringLeft($w[$id][1], StringInStr($w[$id][1], """") -1)
      $txt = StringMid($stat, StringInStr($stat, """name"":") +8)
      $txt = StringLeft($txt, StringInStr($txt, """") -1)
      $w[$id][0] = TrayCreateItem($txt, $w[0][0])
      TrayItemSetOnEvent($w[$id][0], "Senderwahl")
      $stat = StringMid($stat, StringInStr($stat, "}") +1)
      $id += 1
      If $id >= (UBound($w) -4) Then ExitLoop
    WEnd
  EndIf
  $w[0][1] = $id -1
  $w[$id][0] = TrayCreateItem("", $w[0][0])
  $id += 1
  $w[$id][0] = TrayCreateItem("Senderliste &bearbeiten", $w[0][0])
  TrayItemSetOnEvent($w[$id][0], "SenderBearbeiten")
  $w[$id][1] = TrayCreateItem("Se&nderliste aus Datei laden", $w[0][0])
  TrayItemSetOnEvent($w[$id][1], "Senderliste")
  $id += 1
  $w[$id][0] = TrayCreateItem("Senderliste &vom AirLino laden", $w[0][0])
  TrayItemSetOnEvent($w[$id][0], "ListeLaden")
  $w[$id][1] = TrayCreateItem("Senderliste in &Datei speichern", $w[0][0])
  TrayItemSetOnEvent($w[$id][1], "ListeSchreiben")
  $id += 1
  $w[$id][0] = TrayCreateItem("Senderliste im AirLino &speichern", $w[0][0])
  TrayItemSetOnEvent($w[$id][0], "ListeSpeichern")
  $w[$id][1] = TrayCreateItem("Senderliste vom AirLino &lschen", $w[0][0])
  TrayItemSetOnEvent($w[$id][1], "ListeLoeschen")
EndFunc

Func SenderBearbeiten()
  If Not FileExists($edit) Then
    MsgBox(16, $prg, "Das Programm zum Bearbeiten der Senderliste wurde " & _
    "nicht gefunden. Bitte whlen Sie es im nachfolgenden Dialog aus.")
    $edit = FileOpenDialog($prg, @WindowsDir, "Programme (*.exe)", 3)
    If @ERROR Then Return
    If Not @ERROR Then IniSchreiben()
  EndIf
  $pid = Run("""" & $edit & """ """ & $sender[0] & """", "", @SW_MAXIMIZE)
EndFunc

Func ListeLaden()
  $id = EingabeZahl()
  If @ERROR = 1 Then Return 1
  ListePruefen($id)
  If @ERROR Then Return
  Senderliste(2)
EndFunc

Func ListeSchreiben()
  $sender[1] = $sender[0]
  Do
    $sender[0] = FileSaveDialog($prg, @WorkingDir, "Senderlisten (*.ini)", 16)
    If @ERROR Then
      $sender[0] = $sender[1]
      Return
    EndIf
    If $sender[0] = $ini Then
      $sender[0] = ""
      MsgBox(16, $prg, "In der " & $prg & " Konfigurationsdatei kann keine Senderliste gespeichert werden.")
    EndIf
  Until $sender[0] <> ""
  $handle = FileOpen($sender[0], 514)
  If $handle = -1 Then
    MsgBox(16, $prg, "Fehler beim Speichern der Senderliste.")
    Return
  EndIf
  For $x = 1 To $w[0][1]
    FileWriteLine($handle, TrayItemGetText($w[$x][0]))
    FileWriteLine($handle, $w[$x][1])
  Next
  FileClose($handle)
  MsgBox(64, $prg, "Die aktuelle Senderliste wurde erfolgreich gespeichert.")
EndFunc

Func ListeSpeichern($set=$set)
  Local $info = $prg & " - Senderliste"
  If $set = 1 Then
    $id = EingabeZahl()
    If @ERROR = 1 Then Return 1
    $info = InputBox($prg, "Eine kurze Beschreibung fr die Liste:", $info)
    If @ERROR = 1 Then Return
  EndIf
  $txt = "{""action"":""saveplaylist"",""listid"":" & $id & ",""playlist"":" & _
  "{""description"":""" & $info & """,""stationlist"":["
  For $x = 1 To $w[0][1]
    $txt &= "{""name"":""" & TrayItemGetText($w[$x][0]) & _
    """,""url"":""" & $w[$x][1] & """}"
    If $x < $w[0][1] Then $txt &= ","
  Next
  $txt &= "]}}"
  $stat = Abfrage("radio", $txt)
  If @ERROR Or ($stat <> $success) Then
    MsgBox(16, $prg, $stat)
  Else
    If $set = 1 Then MsgBox(64, $prg, "Die Senderliste wurde erfolgreich " & _
    "unter der Nummer " & $id & " im AirLino gespeichert.")
  EndIf
EndFunc

Func ListeLoeschen()
  $id = EingabeZahl()
  If @ERROR Then Return 1
  ListePruefen($id)
  If @ERROR Then Return
  $stat = Abfrage("radio", "{""action"":""getfavouriteplaylist""}")
  If @ERROR Then MsgBox(16, $prg, $stat)
  $txt = StringMid($stat, StringInStr($stat, """listid"":") +10)
  $txt = StringLeft($txt, StringInStr($txt, """") -1)
  If $id = $txt Then
    $stat = Abfrage("radio", "{""action"":""setfavouriteplaylist""}")
    If @ERROR Or ($stat <> $success) Then MsgBox(16, $prg, $stat)
  EndIf
  $stat = Abfrage("radio", StringFormat( _
  "{""action"":""rmplaylist"",""listid"":%s}", $id))
  If @ERROR Or ($stat <> $success) Then
    MsgBox(16, $prg, $stat)
  Else
    MsgBox(64, $prg, "Die Senderliste mit der Nummer " & $id & " wurde " & _
    "erfolgreich vom AirLino gelscht.")
  EndIf
EndFunc

Func EingabeZahl($min=0,$max=128)
  Local $zahl = 100, $pos[2]
  Do
    $zahl = InputBox($prg, "Nummer der gewnschten Senderliste (" & _
    $min & " - " & $max & ")?", $zahl)
    If @ERROR = 1 Then Return SetError(1)
    If StringInStr($zahl, ",") Then
      $pos = StringSplit($zahl, ",", 2)
      $zahl = $pos[0]
    EndIf
  Until StringIsDigit($zahl) And ($zahl >= $min) And ($zahl <= $max)
  Return SetError(0, $pos[1], $zahl)
EndFunc

Func ListePruefen($listid,$set=$set)
  $stat = Abfrage("radio", StringFormat( _
  "{""action"":""getplaylist"",""listid"":""%s""}", $listid))
  If @ERROR Then Return SetError(@ERROR)
  If $stat = "{}" Then
    If $set = 1 Then
      MsgBox(16, $prg, "Die Senderliste " & $listid & " enthlt keine Eintrge.")
      Return SetError(1)
    Else
      ListeSpeichern(0)
    EndIf
  EndIf
EndFunc

Func NetzWaehlen()
  $id = @TRAY_ID - $e[0][1]
  If $an = $e[$id][0] Then
    $txt = TrayItemGetText(@TRAY_ID)
    MsgBox(64, $prg, $name & " ist bereits mit dem Netzwerk """ & $txt & """ verbunden.")
  Else
    $stat = Abfrage("wifi", StringFormat( _
    "{""action"":""selectnetwork"",""id"":%s}", $e[$id][0]))
    If @ERROR Or ($stat <> $success) Then
      MsgBox(16, $prg, $stat)
    Else
      $an = $e[$id][0]
      MsgBox(64, $prg, "Das aktive Netzwerk wurde erfolgreich gendert." & _
      @crlf & "Das Programm wird nun beendet und kann erneut gestartet " & _
      "werden, wenn Ihr Computer mit dem gleichen Netzwerk wie der AirLino verbunden ist.")
      _Exit()
    EndIf
  EndIf
EndFunc

Func NetzLoeschen()
  $id = @TRAY_ID - $e[0][2]
  $txt = TrayItemGetText(@TRAY_ID)
  $wahl = 0
  If $an = $e[$id][0] Then
    $wahl = MsgBox(292, $prg, $name & " ist momentan mit dem Netzwerk """ & _
    $txt & """ verbunden." & @crlf & "Mchten Sie wirklich das aktive Netzwerk lschen?", 10)
    If $wahl <> 6 Then Return
  EndIf
  TraySetToolTip($prg & ": (Netzwerk wird gelscht)")
  $stat = Abfrage("wifi", StringFormat( _
  "{""action"":""removenetwork"",""id"":%s}", $e[$id][0]))
  If @ERROR Or ($stat <> $success) Then
    TraySetToolTip($titel[0])
    MsgBox(16, $prg, $stat)
  Else
    If $wahl = 6 Then
      MsgBox(64, $prg, "Das aktive Netzwerk wurde gelscht und die " & _
      "Verbindung getrennt; das Programm wird nun beendet.")
      _Exit()
    Else
      Netzwerk()
      MsgBox(64, $prg, "Das Netzwerk wurde gelscht.")
    EndIf
  EndIf
EndFunc

Func NeuesNetz()
  Local $ssid, $psk
  TraySetToolTip($prg & ": (Netze werden gesucht)")
  $stat = Abfrage("wifi", "{""action"":""scan""}")
  If @ERROR Then MsgBox(16, $prg, $stat)
  While StringInStr($stat, """ssid"":")
    $ssid = StringMid($stat, StringInStr($stat, """ssid"":") +8)
    $ssid = StringLeft($ssid, StringInStr($ssid, """") -1)
    $wahl = MsgBox(36, $prg, "Mchten Sie das Netzwerk """ & $ssid & _
    """ hinzufgen?" & @crlf & "Wenn Sie ""nein"" whlen, werden evtl. " & _
    "weitere Netze in Ihrer Umgebung angezeigt.")
    If $wahl = 6 Then ExitLoop
    $stat = StringMid($stat, StringInStr($stat, $ssid) + StringLen($ssid) +1)
  WEnd
  If StringInStr($stat, """ssid"":") = 0 Then
    MsgBox(64, $prg, "Es wurden keine oder keine weiteren Netze gefunden. " & _
    "Sie knnen das gewnschte Netzwerk jetzt manuell anlegen.")
    $ssid = InputBox($prg, "Name des neuen Netzwerks (SSID):", $ssid, " m")
    If @ERROR = 1 Then
      TraySetToolTip($titel[0])
      Return 1
    EndIf
  EndIf
  $psk = InputBox($prg, "Passwort fr " & $ssid & ":", "", "*")
  If @ERROR = 1 Then
    TraySetToolTip($titel[0])
    Return 1
  EndIf
  TraySetToolTip($prg & ": (" & $ssid & " wird gespeichert)")
  $stat = Abfrage("wifi", StringFormat( _
  "{""action"":""addnetwork"",""ssid"":""%s"",""psk"":""%s""}", $ssid, $psk))
  If @ERROR Then MsgBox(16, $prg, $stat)
  If StringInStr($stat, """id"":") Then
    If $mode = "AP" Then
      $id = StringMid($stat, StringInStr($stat, """id"":") +5)
      $id = StringLeft($id, StringInStr($id, ",") -1)
      $stat = Abfrage("wifi", StringFormat( _
      "{""action"":""selectnetwork"",""id"":%s}", $id))
      If @ERROR Or ($stat <> $success) Then
        MsgBox(16, $prg, $stat)
        Return 1
      Else
        MsgBox(64, $prg, "Die Netzwerkverbindung wurde eingerichtet. " & _
        "Verbinden Sie den Computer jetzt bitte wieder mit Ihrem Heimnetz " & _
        "und starten Sie anschlieend das Programm erneut.")
        _Exit()
      EndIf
    Else
      Netzwerk()
      MsgBox(64, $prg, "Das Netzwerk """ & $ssid & """ wurde gespeichert " & _
      "und kann jetzt ber das Men ausgewhlt werden.")
    EndIf
  Else
    TraySetToolTip($titel[0])
    Return 1
  EndIf
EndFunc

Func IniSchreiben()
  IniWrite($ini, $prg, "Zwischenablage", $cb)
  IniWrite($ini, $prg, "Sprechblasen", $tt)
  IniWrite($ini, $prg, "Senderliste", $sender[0])
  IniWrite($ini, $prg, "Editor", $edit)
  If $host[0] = $ip[0] Then
    $host[0] = _TCPIpToName($ip[0])
    If @ERROR Then $host[0] = $ip[0]
  EndIf
  IniWrite($ini, $prg, "Host", $host[0])
  IniWrite($ini, $prg, "Port", $port)
  IniWrite($ini, $prg, "API", $api)
  IniWrite($ini, $prg, "TCPTimeout", $to)
  IniWrite($ini, $prg, "Update_URL", $updateurl)
EndFunc

Func _Exit()
  TCPShutdown()
  Exit
EndFunc